// Zad 1
function sumOfThreeNumbers(arr) {
	const num1 = parseInt(arr[0]);
	const num2 = parseInt(arr[1]);
	const num3 = parseInt(arr[2]);
	const sum = num1 + num2 + num3;
	console.log(sum);
}

sumOfThreeNumbers(['2', '3', '4']); // Output: 9

// Zad 2
function calculateVAT(prices) {
	const sum = prices.reduce((acc, curr) => acc + parseFloat(curr), 0);
	const vat = 0.2 * sum;
	const total = sum + vat;
	console.log(`Sum: ${sum.toFixed(2)}, VAT: ${vat.toFixed(2)}, Total: ${total.toFixed(2)}`);
}

calculateVAT(['10.5', '20', '15.75']); // Output: Sum: 46.25, VAT: 9.25, Total: 55.50

// Zad 3
function countLetterOccurrences(arr) {
	const inputString = arr[0];
	const targetLetter = arr[1];
	const occurrences = inputString.split(targetLetter).length - 1;
	console.log(occurrences);
}

countLetterOccurrences(['hello', 'l']); // Output: 2

// Zad 4
function findArea([width, height, Width, Height]) {
	return width * height + Width * Height - Math.min(width, Width) * Math.min(height, Height);
}

console.log(`The area is: ${findArea(['2', '3', '4', '5'])}`);

// Zad 5
function isLeapYear(year) {
	if ((year % 4 === 0 && year % 100 !== 0) || year % 400 === 0) {
		console.log('Yes');
	} else {
		console.log('No');
	}
}

isLeapYear(2024); // Output: Yes

// Zad 6
function printNumbers(n) {
	let result = '';
	for (let i = 1; i <= n; i++) {
		result += i;
	}
	console.log(result);
}

printNumbers(5); // Output: 12345

// Zad 7
function calculateDistance(points) {
	const x1 = parseFloat(points[0]);
	const y1 = parseFloat(points[1]);
	const x2 = parseFloat(points[2]);
	const y2 = parseFloat(points[3]);

	const distance = Math.sqrt((x2 - x1) ** 2 + (y2 - y1) ** 2);
	console.log(distance.toFixed(2));
}

calculateDistance([1, 2, 4, 6]); // Output: 5.00

// Zad 8
function calculateBoxes(bottles, capacity) {
	const boxesNeeded = Math.ceil(bottles / capacity);
	console.log(boxesNeeded);
}

calculateBoxes(20, 5); // Output: 4

// Zad 9
function triangleArea(array) {
	if (array.length !== 3) {
		console.log('Invalid input');
		return;
	}

	if (array.some(x => x <= 0)) {
		console.log('Invalid input');
		return;
	}

	const p = (array[0] + array[1] + array[2]) / 2;
	return Math.sqrt(p * (p - array[0]) * (p - array[1]) * (p - array[2]));
}

console.log(`The area is: ${triangleArea([3, 4, 5])}`);

// Zad 10
function calculateConeVolumeAndSurface(radius, height) {
	const volume = (1 / 3) * Math.PI * Math.pow(radius, 2) * height;
	const surfaceArea = Math.PI * radius * (radius + Math.sqrt(Math.pow(height, 2) + Math.pow(radius, 2)));
	console.log(`Volume: ${volume.toFixed(2)}, Surface Area: ${surfaceArea.toFixed(2)}`);
}

calculateConeVolumeAndSurface(5, 8);

// Zad 11
function checkEvenOrOdd(number) {
	if (isNaN(number)) {
		console.log('Invalid input');
	} else if (number % 2 === 0) {
		console.log('Even');
	} else {
		console.log('Odd');
	}
}

checkEvenOrOdd(7); // Output: Odd

// Zad 12
function isPrime(number) {
	if (number <= 1) {
		console.log('Not prime');
		return;
	}
	for (let i = 2; i <= Math.sqrt(number); i++) {
		if (number % i === 0) {
			console.log('Not prime');
			return;
		}
	}
	console.log('Prime');
}

isPrime(13); // Output: Prime

// Zad 13
function calculateDistance(speed1, speed2, timeInSeconds) {
	const distance1 = (speed1 * timeInSeconds) / 3600; // Convert seconds to hours
	const distance2 = (speed2 * timeInSeconds) / 3600;
	const totalDistance = Math.abs(distance1 - distance2); // Distance can't be negative
	console.log(`Distance: ${totalDistance.toFixed(2)} meters`);
}

calculateDistance(60, 80, 3600); // Output: Distance: 8000.00 meters

// Zad 14
function createObjectFromProperties(properties) {
	const obj = {};
	for (let i = 0; i < properties.length; i += 2) {
		const key = properties[i];
		const value = properties[i + 1];
		obj[key] = value;
	}
	console.log(obj);
}

createObjectFromProperties(['name', 'Pesho', 'age', '23', 'gender', 'male']);

// Zad 15
function findMaxNumber(numbers) {
	const max = Math.max(...numbers);
	console.log(max);
}

findMaxNumber([5, 12, 8]); // Output: 12

// Zad 16
function calculate(operator, num1, num2) {
	let result;
	switch (operator) {
		case '+':
			result = num1 + num2;
			break;
		case '-':
			result = num1 - num2;
			break;
		case '*':
			result = num1 * num2;
			break;
		case '/':
			result = num1 / num2;
			break;
		default:
			console.log('Invalid operator');
			return;
	}
	console.log(result);
}

calculate('*', 18, -1); // Output: -18

// Zad 17
function uppercaseWords(inputString) {
	const words = inputString.match(/\b\w+\b/g); // Extract words
	const uppercaseWords = words.map(word => word.toUpperCase());
	console.log(uppercaseWords.join(', '));
}

uppercaseWords('Hi, how are you?'); // Output: HI, HOW, ARE, YOU
